UNIT BIGDATA
	SYSTEM FP220AE

//-------------------------------------------------------------------------------------------------------
//
// Units
//
//-------------------------------------------------------------------------------------------------------
USES "Units\U_Barcode"
USES "Units\Unit_BigData_RxTx"

//-------------------------------------------------------------------------------------------------------
//
// CONST/VAR/ALIAS
//
//-------------------------------------------------------------------------------------------------------
CONST


MAX_TIMER_OFFSET                                 : VALUE := 10000000;//=10000sec

PARA_TASTE_F2                                    : VALUE := 294;
        
SEAM_STITCH_MAX                                  : VALUE := 20000;


TASKTIMER_SECTION_MOTORRUN                       : VALUE := 1;
TASKTIMER_SECTION_MOTORSTOP                      : VALUE := 2;

TASKTIME_OFFSET                                  : VALUE := 100000;

//Values for BitOperator()
BIT_OPERATOR_AND                                 : VALUE := 1;
BIT_OPERATOR_OR                                  : VALUE := 2;
BIT_OPERATOR_XOR                                 : VALUE := 3;
BIT_OPERATOR_NOT                                 : VALUE := 4;
BIT_OPERATOR_SHIFT_RIGHT                         : VALUE := 5;
BIT_OPERATOR_SHIFT_LEFT                          : VALUE := 6;

//Values for DoubleOperation()
OP_DIV                                           : VALUE := 1;
OP_MUL                                           : VALUE := 2;
OP_ADD                                           : VALUE := 3;
OP_SUB                                           : VALUE := 4;
OP_RET_H                                         : VALUE := 10;
OP_RET_L                                         : VALUE := 11;

//Values for BigData_SewInformation
SEWINFO_STANDARD                                 : VALUE := 1;
SEWINFO_SHORT                                    : VALUE := 2;
SEWINFO_SPECIAL_BACKTACK                         : VALUE := 3;


VAR
BigData_Enable                                   : VALUE := 0;
Merker_VarioButtons                              : VALUE := 0;
Ablauf_Seam_Data_Manager                         : VALUE := 0;
ASI_temp                                         : VALUE := 0;
ASO_temp                                         : VALUE := 0;
BigData_SendSewInformationInput                  : VALUE := 0;
ServiceCounter_ExecuteCount                      : VALUE := 0;
ServiceCounter_ExecuteTime                       : VALUE := 0;
Flag_StartMotorRunAfterStop                      : BIT := FALSE;
Flag_Bt                                          : BIT := FALSE;
bTrimming                                        : BIT := FALSE;
Flag_AddSequenceInfo                             : BIT := FALSE;
IsDA321                                          : BIT := FALSE;
Merker_EXTERNAL_MACHINE_START                    : BIT := FALSE;






//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
PROCEDURE Barcode_Init()
NewString(STRING_BARCODE,STRING_BARCODE_LENGTH);
ReadDeviceProductString(BARCODE_COM_NR,STRING_BARCODE);
bBarcodeReaderIsPresent := FALSE;
IF (StringLen(STRING_BARCODE) > 2) THEN
 SetDisplayText(STRING_BARCODE,5,0,0);
 bBarcodeReaderIsPresent := TRUE;
ELSE 
 SetDisplayText("No Reader found",5,0,0);
END_IF;
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetServiceCall()
 VAL_SERVICE_NUMBER := StringToValue(STRING_BARCODE);
 BigData_SendString(BIGDATA_ID_SEND_SERVICE_CALL);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE SetUserID()
// IF (Is_UserID_Set()) THEN    
//  BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);
//  VAL_USER_ID_1 := 0;
//  VAL_USER_ID_2 := 0;
//  VAL_USER_ID_3 := 0;
// ELSE    
  strupr(STRING_BARCODE);//alle buchtaben mssen gro sein
  
  //erste 4 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,0,4);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_1 := dummy;
  
  //mittlere 4 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,4,4);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_2 := dummy;
  
  //letzte 2 Stellen in dez
  StringCopy(STRING_NAME_3,"0x");
  StringXCopy(STRING_NAME_2,STRING_BARCODE,8,2);
  StringAppend(STRING_NAME_3,STRING_NAME_2);
  dummy := HexStringToDez(STRING_NAME_3);
  VAL_USER_ID_3 := dummy; 
      
  BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGIN);
// END_IF;
END_PROCEDURE

//***************************************************************************
FUNCTION Fkt_MotorRun() : VALUE
 IF (MotorRun OR (GetSpeed() > 50)) THEN
  Fkt_MotorRun := 1;
 ELSE
  Fkt_MotorRun := 0;
 END_IF; 
 
 
 IF (BigData_ExternalMachine) THEN 
  Fkt_MotorRun := 1;
 END_IF; 
 
END_FUNCTION

//-------------------------------------------------------------------------------------------------------
PROCEDURE InitSequence()
// ClearStitchcounter(STITCHCOUNTER_SEQUECE);
// SetStitchcounter(STITCHCOUNTER_SEQUECE,SEAM_STITCH_MAX);//Stichzhlung Start

 Section_RunTime           := 0;
 Section_StopTime          := 0;
 Seam_Stopp_Counter        := 0;
 Section_GesamtStitchCount := 0;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AddSequenceInfo(ASI_SeamEnd : VALUE)//xxxx
 IF (ASI_SeamEnd = 0) THEN
    ASI_temp := 0;
    ASO_temp := 0;
    Flag_StartMotorRunAfterStop := TRUE;  
 END_IF;

 Flag_AddSequenceInfo := TRUE;
// TotalSeam_RunTime   := TotalSeam_RunTime  + Section_RunTime;
// TotalSeam_StopTime  := TotalSeam_StopTime + Section_StopTime;
 
 //Section_StitchCount := SEAM_STITCH_MAX - GetStitchcounter(STITCHCOUNTER_SEQUECE);
 Section_AverageSpeed      := GetStitchcounter(STITCHCOUNTER_SEAM);//Zhlerwert auf dummy
 Section_StitchCount       := Section_MerkerStitchCount - Section_AverageSpeed;//alt - ist

 IF (BigData_ExternalMachine) THEN 
  TotalSeam_StitchCount := FastCounter;//fast counting (=4) In1
 ELSE
  TotalSeam_StitchCount := TotalSeam_StitchCount + Section_StitchCount;
 END_IF;
 
 ServiceCounter_ExecuteCount := Section_StitchCount;
 
 Section_MerkerStitchCount := Section_AverageSpeed;//alt = ist
 IF (Section_StitchCount < 0) THEN
  Section_StitchCount := 0;
 END_IF;
 Section_GesamtStitchCount := Section_GesamtStitchCount + Section_StitchCount;
 
 
 IF (Section_RunTime < 0) THEN
  Section_RunTime := 0;
 END_IF;
 IF (Section_StopTime < 0) THEN
  Section_StopTime := 0;
 END_IF;


// Section_AverageSpeed := (Section_StitchCount * 100) / (Section_RunTime / 1000);
 MMISSF_RetVal_H        := DoubleOperation(OP_MUL, 0, Section_StitchCount*1, 0, 60000);
 MMISSF_RetVal_H        := DoubleOperation(OP_RET_H,0,0,0,0);
 MMISSF_RetVal_L        := DoubleOperation(OP_RET_L,0,0,0,0); 
 Section_AverageSpeed   := DoubleOperation(OP_DIV, MMISSF_RetVal_H*1, MMISSF_RetVal_L*1, 0, Section_RunTime + Section_StopTime);
 Section_AverageSpeed   := DoubleOperation(OP_RET_L,0,0,0,0); 


 IF (Section_AverageSpeed < 0) THEN
  Section_AverageSpeed := 0;
 END_IF;
 
 SECTION_DATA_Set(ARRAY_SECTION_SEWING_TIME,   Seam_Stopp_Counter*1, Section_RunTime + Section_StopTime);
 SECTION_DATA_Set(ARRAY_SECTION_AVERAGE_SPEED, Seam_Stopp_Counter*1, Section_AverageSpeed*1);
 SECTION_DATA_Set(ARRAY_SECTION_RUN_TIME,      Seam_Stopp_Counter*1, Section_RunTime*1);
 SECTION_DATA_Set(ARRAY_SECTION_STOP_TIME,     Seam_Stopp_Counter*1, Section_StopTime*1);
 SECTION_DATA_Set(ARRAY_SECTION_STITCHES,      Seam_Stopp_Counter*1, Section_StitchCount*1);
 
 SECTION_DATA_Set(ARRAY_SECTION_INPUT_SEWING,  Seam_Stopp_Counter*1, Section_Inputs_Motorrun*1);                      
 SECTION_DATA_Set(ARRAY_SECTION_OUTPUT_SEWING, Seam_Stopp_Counter*1, Section_Outputs_Motorrun*1);                     
 SECTION_DATA_Set(ARRAY_SECTION_INPUT_STOP,    Seam_Stopp_Counter*1, Section_Inputs_MotorStop*1);                         
 SECTION_DATA_Set(ARRAY_SECTION_OUTPUT_STOP,   Seam_Stopp_Counter*1, Section_Outputs_MotorStop*1);                        
 
 //Nchste Sequenz
// ClearStitchcounter(STITCHCOUNTER_SEQUECE);
// SetStitchcounter(STITCHCOUNTER_SEQUECE,SEAM_STITCH_MAX);//Stichzhlung Start
 Seam_Stopp_Counter := Seam_Stopp_Counter + 1;
 Section_RunTime           := 0;
 Section_StopTime          := 0;
 Section_Inputs_Motorrun   := 0;
 Section_Inputs_MotorStop  := 0;
 Section_Outputs_Motorrun  := 0;
 Section_Outputs_MotorStop := 0;
 ClearTimer(TIMER_MOTORSTOP);
 SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);

//CreateDisplay();
//SetDisplayValue(Seam_Stopp_Counter,1,0,0);
//SetBeepShort();
  Flag_AddSequenceInfo := FALSE;

END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AddSequenceInputs(ASI_Mode : VALUE)
 IF (In1) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,1);
 END_IF;
 IF (In2) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,2);
 END_IF;
 IF (In3) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,4);
 END_IF;
 IF (In4) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,8);
 END_IF;
 IF (In5) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,16);
 END_IF;
 IF (In6) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,32);
 END_IF;
 IF (In7) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,64);
 END_IF;
 IF (In8) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,128);
 END_IF;
 IF (In9) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,256);
 END_IF;
 IF (In10) THEN
  ASI_temp := BitOperator(BIT_OPERATOR_OR,ASI_temp,512);
 END_IF;

 
 IF (ASI_Mode) THEN
  Section_Inputs_Motorrun := BitOperator(BIT_OPERATOR_OR,Section_Inputs_Motorrun,ASI_temp);
 ELSE
  Section_Inputs_MotorStop := BitOperator(BIT_OPERATOR_OR,Section_Inputs_MotorStop,ASI_temp);
 END_IF;
 
// SetDisplayValue(Section_Inputs_Motorrun,1,0,0);
// SetDisplayValue(Section_Inputs_MotorStop,2,0,0);
// SetDisplayValue(ASI_temp,3,0,0);

END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE AddSequenceOutputs(ASO_Mode : VALUE)
 IF (SetOut1) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,1);
 END_IF;
 IF (SetOut2) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,2);
 END_IF;
 IF (SetOut3) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,4);
 END_IF;
 IF (SetOut4) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,8);
 END_IF;
 IF (SetOut5) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,16);
 END_IF;
 IF (SetOut6) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,32);
 END_IF;
 IF (SetOut7) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,64);
 END_IF;
 IF (SetOut8) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,128);
 END_IF;
 IF (SetOut9) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,256);
 END_IF;
 IF (SetOut10) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,512);
 END_IF;
 IF (SetOut11) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,1024);
 END_IF;
 IF (SetOut12) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,2048);
 END_IF;
 IF (SetOut13) THEN
  ASO_temp := BitOperator(BIT_OPERATOR_OR,ASO_temp,4096);
 END_IF;

 
 IF (ASO_Mode) THEN
  Section_Outputs_Motorrun := BitOperator(BIT_OPERATOR_OR,Section_Outputs_Motorrun,ASO_temp);
 ELSE
  Section_Outputs_MotorStop := BitOperator(BIT_OPERATOR_OR,Section_Outputs_MotorStop,ASO_temp);
 END_IF;
 
// SetDisplayValue(Section_Outputs_Motorrun,1,0,0);
// SetDisplayValue(Section_Outputs_MotorStop,2,0,0);
// SetDisplayValue(ASO_temp,3,0,0);

END_PROCEDURE


//-------------------------------------------------------------------------------------------------------MotorRun
//Funktion um zu erkennen, wenn der Motor gerade anluft/Flanke MotorRun
PROCEDURE Record_MotorRun(RMR_Val1 : VALUE)//xxxx
  IF (NOT Flag_StartMotorRunAfterStop) THEN
   Flag_StartMotorRunAfterStop := TRUE; 
   SELECT (BigData_SewInformation) OF
    CASE SEWINFO_STANDARD:
     AddSequenceInfo(0);
    CASE SEWINFO_SHORT:
     IF (NOT BeginBt AND NOT EndBt) THEN//damit beim zierriegel nicht eine neue sequenz erstellt wird
      AddSequenceInfo(0);
     END_IF;
    CASE SEWINFO_SPECIAL_BACKTACK: 
     IF (NOT BeginBt AND NOT EndBt) THEN//damit beim zierriegel nicht eine neue sequenz erstellt wird
      AddSequenceInfo(0);
     END_IF;
   END_SELECT;     
  END_IF;
  
//  IF (BeginBt OR EndBt) THEN
   IF (Bt) THEN
    IF (NOT Flag_Bt) THEN
     AddSequenceInfo(0);
     Flag_Bt := TRUE;
    END_IF;
   ELSE
    IF (Flag_Bt) THEN
     AddSequenceInfo(0);
     Flag_Bt := FALSE;
    END_IF;
   END_IF;
//  END_IF;
  
  
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------MotorStop
//Funktion um zu erkennen, wenn der Motor gerade stoppt/Flanke MotorStop
PROCEDURE Record_MotorStop(RMS_Val1 : VALUE)
 IF (Flag_StartMotorRunAfterStop) THEN
  ASI_temp := 0;
  ASO_temp := 0;
  Flag_StartMotorRunAfterStop := FALSE;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------In der Naht
//Whren der Naht: Erkennung wenn Motor luft/steht, Datensammlung der Sectioans
PROCEDURE SewInformation_Cont(RSD_Val1 : VALUE)
 
 //SetDisplayValue(AllSequence_RunTime / 1000,5,0,0);
 
 RSD_Val1 := (MAX_TIMER_OFFSET - GetTimer(TIMER_MOTORSTOP));
 ClearTimer(TIMER_MOTORSTOP);
 SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);  


//------------------------------MotorRun
 IF (Fkt_MotorRun()) THEN
  TotalSeam_RunTime := TotalSeam_RunTime + RSD_Val1;
  Section_RunTime   := Section_RunTime + RSD_Val1;
  Record_MotorRun(0);
  AddSequenceInputs(1);
  AddSequenceOutputs(1);
//------------------------------MotorStop
 ELSE
  TotalSeam_StopTime := TotalSeam_StopTime + RSD_Val1;
  Section_StopTime   := Section_StopTime + RSD_Val1;
  Record_MotorStop(0);
  AddSequenceInputs(0);
  AddSequenceOutputs(0);
 END_IF;

//SetDisplayValue(Section_RunTime / 1000,5,0,0);

END_PROCEDURE

//-------------------------------------------------------------------------------------------------------Nahtanfang
//Bevor Nahtanfang kommt wird alles initialisiert
PROCEDURE SewInformation_Init()
//Nahtinformationen nullen


 TotalSeam_SeamTime               := 0;
 Section_GesamtStitchCount        := 0;
 TotalSeam_AverageSpeed           := 0;
 TotalSeam_RunTime                := 0;
 TotalSeam_StopTime               := 0;
 TotalSeam_StitchCount            := 0;
 
 //Ablauf_StitchCount_Task          := 1;

 //Value_SEAM_END_INPUT := GetParameter(PARA_SEAM_END_INPUT);

 Flag_StartMotorRunAfterStop := TRUE;
 Flag_Bt                     := FALSE; 
//SectionInfos nullen 
 SequenzSeam_StopCount            := 0; 
 
//Timer fr MotorRun und MotorStop
 ClearTimer(TIMER_MOTORSTOP);
 SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);  
 
//Stichzhler fr Sections 
 ClearStitchcounter(STITCHCOUNTER_SEAM);
 SetStitchcounter(STITCHCOUNTER_SEAM,SEAM_STITCH_MAX);
 Section_MerkerStitchCount := SEAM_STITCH_MAX;
 
 InitSequence();
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------Nahtende
//Naht ist Beendet/Es wurde Abgeschniten
PROCEDURE SewInformation_End()
//die letzte Section beenden
 AddSequenceInfo(1);
 
//Gesamtnhzeit berechnen 
 TotalSeam_SeamTime         := TotalSeam_RunTime + TotalSeam_StopTime;

//Berechnung der Durchschnittsdrehzahl der Gesamtnaht
 MMISSF_RetVal_H        := DoubleOperation(OP_MUL, 0, TotalSeam_StitchCount*1, 0, 60000);
 MMISSF_RetVal_H        := DoubleOperation(OP_RET_H,0,0,0,0);
 MMISSF_RetVal_L        := DoubleOperation(OP_RET_L,0,0,0,0); 
 TotalSeam_AverageSpeed := DoubleOperation(OP_DIV, MMISSF_RetVal_H*1, MMISSF_RetVal_L*1, 0, TotalSeam_SeamTime*1);
 TotalSeam_AverageSpeed := DoubleOperation(OP_RET_L,0,0,0,0); 


// CreateDisplay();
// SetDisplayValue(Seam_Stopp_Counter,1,0,0);   
//Anzahl der Stops/Sections
 IF (Seam_Stopp_Counter) THEN
  Seam_Stopp_Counter := Seam_Stopp_Counter - 1;
 END_IF;
 SequenzSeam_StopCount := Seam_Stopp_Counter; 
// SetDisplayValue(Seam_Stopp_Counter,2,0,0);   

END_PROCEDURE







//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
//
// berwachung der Naht: Nahtanfang, Nahtende. Verwalten der Zhler und Timer fr die Datensammlung
//
//-------------------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------------
//Send Seam Information after SeamEnd
PROCEDURE SendSeamEndInformation()
   SELECT (BigData_SewInformation) OF
    CASE SEWINFO_STANDARD:
     BigData_SendString(BIGDATA_ID_SEND_SEW_INFORMATION);
    CASE SEWINFO_SHORT:
     BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
    CASE SEWINFO_SPECIAL_BACKTACK: 
     BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
   END_SELECT;     
   Ablauf_Seam_Data_Manager := 4;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Wait until message was send befor enable new sewing start
PROCEDURE WaitUntilSendSeamEndInformation()
  // WaitUntilSendSeamEndInformation();
//   SetDisplayValue(BigData_TxManager_ActualFillBuffer,2,0,0);
//   SetDisplayValue(BigData_TxManager_ActualSendBuffer,3,0,0);
   
   IF (BigData_TxManager_ActualFillBuffer  = BigData_TxManager_ActualSendBuffer) THEN//wird die nachricht gerade abgeschickt? das bedeutet nicht, dass die nachricht schon ein ack bekommen hat!
    ServiceCounter_ExecuteTime    := TotalSeam_RunTime / 1000;
    TotalSeam_TimeBetweenSeams    := 0;
    Ablauf_Seam_Data_Manager      := 0;
    bTrimming                     := TRUE;
   END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE InitSeamDataManager()
   ClearTimer(TIMER_MOTORSTOP);
   SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);
   Ablauf_Seam_Data_Manager := 1;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE ContSeamDataManager()
   TotalSeam_TimeBetweenSeams := TotalSeam_TimeBetweenSeams + (MAX_TIMER_OFFSET - GetTimer(TIMER_MOTORSTOP));
   ClearTimer(TIMER_MOTORSTOP);
   SetTimer(TIMER_MOTORSTOP, MAX_TIMER_OFFSET);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//special manager for external machines F906=12
PROCEDURE ExternalMachine_Manager(DSM_Cycle_Time : VALUE)

 IF(IN_EXTERNAL_MACHINE_START)THEN 
  Merker_EXTERNAL_MACHINE_START := TRUE;
 END_IF; 

 SELECT (Ablauf_Seam_Data_Manager) OF

  CASE 0://Init
   InitSeamDataManager();
   SetDisplayValue(10000 - GetTimer(Timer5),1,0,0);
   
  CASE 1://Warten auf Nahtanfang 
   ContSeamDataManager();
   IF(Merker_EXTERNAL_MACHINE_START)THEN 
    IRQInXXFunktion (In1,1,4,0);//fast counting (=4) In1
    //Ablauf_StitchCount_Task := 1;
    SewInformation_Init();
    Merker_EXTERNAL_MACHINE_START := FALSE;
    Ablauf_Seam_Data_Manager := 2;
   END_IF; 

  CASE 2://Warten auf Nahtende
   SewInformation_Cont(0);
   
   IF (IN_EXTERNAL_MACHINE_END) THEN
    SewInformation_End();    
    Ablauf_Seam_Data_Manager := 3;
   END_IF; 

//Nahtinfo schicken nach Abschneider
  CASE 3://SeamEnd Nachricht schicken
   ClearTimer(Timer5);
   SetTimer(Timer5,10000);
   SendSeamEndInformation();

  CASE 4://Warten bis Nachricht geschickt wurde
   WaitUntilSendSeamEndInformation();
   IF (Ablauf_Seam_Data_Manager = 0) THEN
    Ablauf_Seam_Data_Manager := 5;
   END_IF;
   
  CASE 5:
   ///Waitms(2000);
   FastCounter := 0;
   Ablauf_Seam_Data_Manager := 0;
    
 END_SELECT;
 
// SetDisplayValue(Ablauf_Seam_Data_Manager,1,0,0);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------Naht Manager
//seam information collection manager
PROCEDURE Seam_Data_neuManager(DSM_Cycle_Time : VALUE)

//  SetEnableFpPedal  := OFF;
//  SetDisablePedal   := OFF;
//  SetRunBlockage    := OFF;
//SetDisplayValue(Ablauf_Seam_Data_Manager,3,0,0);
//IF (WaitForSeamBegin) THEN
//SetDisplayValue(1,2,0,0);
//ELSE
//SetDisplayValue(2,2,0,0);
//END_IF;
//SetDisplayValue(Seam_Stopp_Counter,3,0,0);
 BigData_SendSewInformationInput := IsSeamInputSet(0);

 SELECT (Ablauf_Seam_Data_Manager) OF

  CASE 0://Init
   SetWaitForSeamBegin  := ON;
   InitSeamDataManager();

  CASE 1://Warten auf Nahtanfang 
   ContSeamDataManager();
   IF(WaitForSeamBegin)THEN //xxxx
    //Ablauf_StitchCount_Task := 1;
    SewInformation_Init();
    SetWaitForSeamEnd   := ON;
    SetWaitForSeamBegin := OFF;
    Ablauf_Seam_Data_Manager := 2;
   END_IF; 

  CASE 2://Warten auf Nahtende
   SewInformation_Cont(0);

   IF (WaitForSeamEnd) THEN
    SewInformation_End();    
    SetWaitForSeamBegin := ON;
    SetWaitForSeamEnd   := OFF;   
    Ablauf_Seam_Data_Manager := 3;
   END_IF; 
   IF ( ((BigData_SendSewInformationWhenPedal0 > 0) AND Pedal0) OR (BigData_SendSewInformationInput > 0) ) THEN
    //SetBeepShort();
    IF (BigData_SendSewInformationInput) THEN
     SetStopNoPosition := ON;//Anlauf sofort sperren
    ELSE
     Waitms(50);
     SetStopNoPosition := ON;//Anlauf sperren wenn motor steht
    END_IF;
    SewInformation_End();    
    Ablauf_Seam_Data_Manager := 10;
   END_IF;
   
//Nahtinfo schicken nach Abschneider
  CASE 3://SeamEnd Nachricht schicken
   SendSeamEndInformation();
  CASE 4://Warten bis Nachricht geschickt wurde
   WaitUntilSendSeamEndInformation();
 
 
//Nahtinfo schicken / Sonderfall
  CASE 10://Sonderfall, wenn nicht abgeschnitten wurde sondern anders die Nahtinformation geschickt werden soll
   SELECT (BigData_SewInformation) OF
    CASE SEWINFO_STANDARD:
     BigData_SendString(BIGDATA_ID_SEND_SEW_INFORMATION);
    CASE SEWINFO_SHORT:
     BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
    CASE SEWINFO_SPECIAL_BACKTACK: 
     BigData_SendString(BIGDATA_ID_SEND_SHORT_SEW_INFORMATION);
   END_SELECT;     
   Ablauf_Seam_Data_Manager := 11;
  CASE 11:
   IF (BigData_TxManager_ActualFillBuffer  = BigData_TxManager_ActualSendBuffer) THEN//wird die nachricht gerade abgeschickt? das bedeutet nicht, dass die nachricht schon ein ack bekommen hat!
    ServiceCounter_ExecuteTime    := TotalSeam_RunTime / 1000;
    TotalSeam_TimeBetweenSeams    := 0;
    Ablauf_Seam_Data_Manager      := 2;
    bTrimming                     := TRUE;
    SewInformation_Init();
    SetStopNoPosition := OFF;//Anlauf freigeben
   END_IF;

 END_SELECT;
 
// CreateDisplay();
// SetDisplayValue(BigData_TxManager_ActualFillBuffer,1,0,0);
// SetDisplayValue(BigData_TxManager_ActualSendBuffer,2,0,0);
 
END_PROCEDURE




//-------------------------------------------------------------------------------------------------------
//Basiswert der Variablen nach dem Einschalten
PROCEDURE InitVars()
dummy                                            := 0;
Ablauf_Menu                                      := 0;
Merker_VarioButtons                              := 0;
TempVal1                                         := 0;
Anzeige_Naht_Text_neu                            := 0;
Anzeige_Naht_Text_alt                            := 0;
Ablauf_Seam_Data_Manager                         := 0;
Seam_Time_Second_Counter                         := 0;
Seam_Stitch_Counter                              := 0;
Seam_Stopp_Counter                               := 0;

SetParameter(PARA_TASTE_F2,0);

DevSendStringNoAck := TRUE;//disable acknolage of devsendstring commands
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Nach PowerOn werden die letzten Werte geladen
PROCEDURE PieceCounter_PowerOn()
 PieceCounter_COUNT_MAX := GetParameter(PARA_PIECECOUNTER_COUNT_MAX);
 PieceCounter_COUNT_Act := GetParameter(PARA_PIECECOUNTER_COUNT_Act);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Piececounter. Bei jedem Abschneiden wird der Zhler erhht. Bei Erreichen des Maximalwerts wird eine
//Nachricht an den PC gesendet un der Zhler auf 0 gesezt
PROCEDURE PieceCounter_Manager()
 IF (PieceCounter_COUNT_MAX) THEN//Ist Piececounter aktiv?
  IF (bTrimming) THEN//Wurde abgeschnitten?
   bTrimming := FALSE;
   IF (PieceCounter_COUNT_Act < PieceCounter_COUNT_MAX - 1) THEN//Ist Maximalwert schon erreicht?
    PieceCounter_COUNT_Act := PieceCounter_COUNT_Act + 1;
   ELSE//Maximalwert ist erreicht -> Nachricht senden, init des Zhlers
    PieceCounter_COUNT_Act := 0;
    BigData_SendString(BIGDATA_ID_SEND_PIECECOUNTER_READY_0);   
    //SetBeepShort();
   END_IF; 
   SetParameter(PARA_PIECECOUNTER_COUNT_Act,PieceCounter_COUNT_Act);
  END_IF;
// CreateDisplay();
// SetDisplayValue(PieceCounter_COUNT_Act,1,0,0);
// SetDisplayValue(PieceCounter_COUNT_MAX,2,0,0);
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//Nach PowerOn werden die letzten Werte geladen
PROCEDURE ServiceCounter_PowerOn()
 ServiceCounter_Startwert_1 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_1);
 ServiceCounter_Mode_1      := GetParameter(PARA_SERVICECOUNTER_MODE_1);
 ServiceCounter_Act_1       := GetParameter(PARA_SERVICECOUNTER_ACT_1);
 ServiceCounter_Startwert_2 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_2);
 ServiceCounter_Mode_2      := GetParameter(PARA_SERVICECOUNTER_MODE_2);
 ServiceCounter_Act_2       := GetParameter(PARA_SERVICECOUNTER_ACT_2);
 ServiceCounter_Startwert_3 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_3);
 ServiceCounter_Mode_3      := GetParameter(PARA_SERVICECOUNTER_MODE_3);
 ServiceCounter_Act_3       := GetParameter(PARA_SERVICECOUNTER_ACT_3);
 ServiceCounter_Startwert_4 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_4);
 ServiceCounter_Mode_4      := GetParameter(PARA_SERVICECOUNTER_MODE_4);
 ServiceCounter_Act_4       := GetParameter(PARA_SERVICECOUNTER_ACT_4);
 ServiceCounter_Startwert_5 := GetParameter(PARA_SERVICECOUNTER_STARTWERT_5);
 ServiceCounter_Mode_5      := GetParameter(PARA_SERVICECOUNTER_MODE_5);
 ServiceCounter_Act_5       := GetParameter(PARA_SERVICECOUNTER_ACT_5);
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//ServiceCounter. Es wird berprft ob der ServiceCounter abgelaufen ist und eine entsprechende Nachricht gesendet.
//Danach wird der ServiceCounter automatisch wieder gestartet
FUNCTION ServiceCounter_Manager(SCM_ID : VALUE, SCM_Startwert : VALUE, SCM_Mode : VALUE, SCM_Act : VALUE, SCM_Save : VALUE) : VALUE
 IF (SCM_Startwert*1) THEN//Ist Counter aktiv?
  SELECT (SCM_Mode*1) OF//Zeit oder Stiche vom aktuellen Wert abziehen
   CASE SERVICECOUNTER_MODE_TIMER:
    IF (ServiceCounter_ExecuteTime > 0) THEN
       SCM_Act := GetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1) + ServiceCounter_ExecuteTime;//Aktueller Wert + gesammelte Zeit
       IF (SCM_Act >= 3600) THEN//Ist schon eine Stunde um?
        SCM_Act := 0;//Sekunden wieder auf NULL setzen
        SetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1, SCM_Act*1);//Sekunden speichern
        SCM_Act := GetParameter(PARA_SERVICECOUNTER_ACT_1 + SCM_ID - 1);//Aktuellen Stundenwert holen
        IF (SCM_Act >= 1) THEN
         SCM_Act := SCM_Act - 1;//eine Stunde abziehen
        ELSE
         SetParameter(PARA_SERVICECOUNTER_ACT_1 + SCM_ID - 1, SCM_Startwert*1);
         SELECT (SCM_ID*1) OF//Abschicken der Nachricht
          CASE 1:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_0);   
          CASE 2:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_1);   
          CASE 3:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_2);   
          CASE 4:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_3);   
          CASE 5:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_4);   
         END_SELECT;
        END_IF;
       ELSE
        SetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1, SCM_Act*1);//neuen Wert speichern
       END_IF;
//       CreateDisplay();
//       SetDisplayValue(ServiceCounter_ExecuteTime,1,0,0);
//       SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_SEC_1 + SCM_ID - 1),2,0,0);
//       SetDisplayValue(SCM_Act*1,3,0,0);
    END_IF;
   CASE SERVICECOUNTER_MODE_COUNTER:
    IF (ServiceCounter_ExecuteCount) THEN
     SCM_Act := SCM_Act - ServiceCounter_ExecuteCount;
     SCM_Save := 1;
    END_IF;
  END_SELECT;
  IF (SCM_Act <= 0) THEN//Wenn der aktuelle Wert kleiner 0 ist, ist der Zhler abglaufen
   SCM_Act := SCM_Startwert*1;//ReInit des aktuelle Wert
//   SetBeepShort();
   SELECT (SCM_ID*1) OF//Abschicken der Nachricht
    CASE 1:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_0);   
    CASE 2:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_1);   
    CASE 3:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_2);   
    CASE 4:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_3);   
    CASE 5:     BigData_SendString(BIGDATA_ID_SEND_SERVICECOUNTER_READY_4);   
   END_SELECT;
   SCM_Save := 1;
  END_IF;
  IF (SCM_Save) THEN//Bei nderung des Wertes wird auch gespeichert
   SELECT (SCM_ID*1) OF
    CASE 1:     SetParameter(PARA_SERVICECOUNTER_ACT_1,       SCM_Act*1);
    CASE 2:     SetParameter(PARA_SERVICECOUNTER_ACT_2,       SCM_Act*1);   
    CASE 3:     SetParameter(PARA_SERVICECOUNTER_ACT_3,       SCM_Act*1);  
    CASE 4:     SetParameter(PARA_SERVICECOUNTER_ACT_4,       SCM_Act*1); 
    CASE 5:     SetParameter(PARA_SERVICECOUNTER_ACT_5,       SCM_Act*1);  
   END_SELECT;
  END_IF;
//  CreateDisplay();
//  SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_SEC_1),1,0,0);
//  SetDisplayValue(GetParameter(PARA_SERVICECOUNTER_ACT_1),2,0,0);
//  SetDisplayValue(SCM_ID*1,3,0,0);
 END_IF;
 ServiceCounter_Manager := SCM_Act*1;//Aktuellen Wert immer zurckgeben
END_FUNCTION

//-------------------------------------------------------------------------------------------------------
//
// Main Functions
//
//-------------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------------
TASK HilfsTask()
 IF (BeginBt) THEN
  SetOut1 := ON;
 ELSE 
  SetOut1 := OFF;
 END_IF;
 IF (Bt) THEN
  SetOut2 := ON;
 ELSE 
  SetOut2 := OFF;
 END_IF;
 IF (EndBt) THEN
  SetOut3 := ON;
 ELSE 
  SetOut3 := OFF;
 END_IF;
 IF (SeamFreeRun) THEN
  SetOut4 := ON;
 ELSE 
  SetOut4 := OFF;
 END_IF;
 IF (Position1) THEN
  SetOut5 := ON;
 ELSE 
  SetOut5 := OFF;
 END_IF;
 IF (Fkt_MotorRun()) THEN
  SetOut6 := ON;
 ELSE 
  SetOut6 := OFF;
 END_IF;
 IF (Ablauf_Seam_Data_Manager = 2) THEN
  SetOut7 := ON;
 ELSE 
  SetOut7 := OFF;
 END_IF;
 IF (Flag_AddSequenceInfo) THEN
  SetOut8 := ON;
 ELSE 
  SetOut8 := OFF;
 END_IF; 
 BreakTask();
END_TASK

//-------------------------------------------------------------------------------------------------------
PROCEDURE Fkt_Debug_Signale_Active()
IF (Val_DEBUG_SIGNALS_ACTIVE) THEN
 SetDisableOutM1 := ON;
 SetDisableOutM2 := ON;
 SetDisableOutM3 := ON;
 SetDisableOutM4 := ON;
 SetDisableOutM5 := ON;
 SetDisableOutM6 := ON;
 SetDisableOutM7 := ON;
 SetDisableOutM8 := ON;
 START HilfsTask;
END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
//Debug routine to download compiler software by IF232 cable and set all neccessary standard parameters
//to download compiler software you have to switch In7=ON until download is finished
PROCEDURE Fkt_Debug_Active()
 CreateDisplay();
 SetEnableFpPedal := ON;
 IF (Val_DEBUG_ACTIVE OR Val_DEBUG_SIGNALS_ACTIVE) THEN
  SetDisplayText("!!! DEBUG !!!",5,0,0);
  Waitms(500);
 ELSE
  //SetDisplayValue(VERSIONSNUMMER,1,0,0);
  //SetDisplayText("BigData",3,0,0);
  DisplayCharacterSet("v",1,0);
  DisplayValuePositionSet(VERSIONSNUMMER,2,2);
  DisplayCharacterSet("BigData",5,0);
  
 END_IF; 
 WHILE (USBEnumerationIsActive)
  BreakTask();
 END_WHILE;

 IF (Val_DEBUG_ACTIVE) THEN
  IF (In7) THEN
   SetDisplayText("In7  ON",1,0,0);
   SetParameter(413,1);  
   IF (ParaExist(280)) THEN//Only for DA321
    SetParameter(280,1000);
    SetParameter(290,20);
   ELSE
    SetParameter(290,5);
   END_IF;
   SetParameter(111,1500);
   SetParameter(PARA_BIGDATA_MODE,BIGDATA_MODE_5);
   SetParameter(799,222);
   SetParameter(413,6);
   SetParameter(241,0);
   SetParameter(270,0);
   WHILE (In7)
   END_WHILE;
   CreateDisplay();
   Fkt_Debug_Signale_Active();
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Begin()//

IF (GetParameter(PARA_DEBUG_ACTIVE) = 0) THEN
 Val_DEBUG_ACTIVE := FALSE;
ELSE
 Val_DEBUG_ACTIVE := TRUE;
END_IF;
IF (GetParameter(PARA_DEBUG_SIGNALS_ACTIVE) = 0) THEN
 Val_DEBUG_SIGNALS_ACTIVE := FALSE;
ELSE
 Val_DEBUG_SIGNALS_ACTIVE := TRUE;
END_IF;

Fkt_Debug_Active();

IF (ParaExist(280)) THEN//Only for DA321
 IsDA321 := TRUE;
END_IF;

BigData_DataMode    := GetParameter(PARA_BIGDATA_MODE);

IF (BigData_DataMode) THEN
 SetDisplayText("Init Strings",5,0,0);
 NewString(STRING_CODE,             SIZE_STRING_TEMP);
 NewString(STRING_CODE2,            SIZE_STRING_TEMP);
 NewString(STRING_Tx,               SIZE_STRING_TEMP); 
 //NewString(STRING_Rx,               SIZE_STRING_TEMP);
 NewString(STRING_TEMP1,            SIZE_STRING_TEMP);
 NewString(STRING_BigDataString,    SIZE_STRING_TEMP);
 NewString(STRING_TEMP2,            SIZE_STRING_TEMP);
 NewString(STRING_OPERATOR,         SIZE_STRING_TEMP);
 
 NewString(STRING_NAME_1,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_2,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_3,           SIZE_STRING_TEMP);
 NewString(STRING_NAME_4,           SIZE_STRING_TEMP);
 
 NewString(STRING_BARCODE,          STRING_BARCODE_LENGTH);
 
 SetDisplayText("Init ID",5,0,0);
  VAL_PARA_MACHINE_ID := GetParameter(PARA_MACHINE_ID1);//F799
  IF (ParaExist(PARA_MACHINE_ID2)) THEN
   IF (GetParameter(PARA_MACHINE_ID2) > 0) THEN
    VAL_PARA_MACHINE_ID := GetParameter(PARA_MACHINE_ID2);//F907
   END_IF;
  END_IF;
  BigData_Enable      := GetSystemInfo(SYSTEMINFO_BigData_SoftwareEnable);
  IF (BigData_Enable) THEN
   Ablauf_BigData_Cont := 500;    
  ELSE
   Ablauf_BigData_Cont := 1;
  END_IF; 
 SetDisplayText("Init Version",5,0,0);
  SetParameter(PARA_VERSION,VERSIONSNUMMER);
  SetParameter(PARA_EFKA_PROJEKTNUMMER,EFKA_PROJEKTNUMMER);
 SetDisplayText("Init Array",5,0,0);
  NewBigDataArray(); 
 SetDisplayText("Init Variables",5,0,0);
  InitVars();//BRC disable
  SetParameter(412,1);//Baudrate 9600
  SetParameter(413,6);//control box broadcast 6=BigData
  SetParameter(414,1);//control box device adress
 SetDisplayText("Init Dongle",5,0,0);
  dummy := GetSystemInfo(SYSTEMINFO_Dongle_Init);
  dummy := GetSystemInfo(SYSTEMINFO_Dongle_Get);
  
 //SetDisplayText("Get  Sysinfo",5,0,0);
 //DataDump_AmoutOfData          := GetSystemInfo(SYSTEMINFO_BigData_GetAmountParameterList);
END_IF; 
 
 
// WHILE (1)
//  SetDisplayText("ok",1,0,0);
// END_WHILE;
 
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Init()//
 SetTaskTime(TASKTIME_MAX); 
// IF (BigData_DataMode) THEN
SetDisplayText("Init BigData",5,0,0);
 StringMessageMode := SetSystemInfo(SYSTEMINFO_StringMessageMode,0);
 DataDump_len_pardef_cmn := GetSystemInfo(SYSTEMINFO_len_pardef_cmn);

 BigData_Ack_Mode                      := BIGDATA_ACK_MODE_WITH_ACK;
 BigData_TxD_RepeatTime                := BIGDATA_TX_REPEATTIME;
 BigData_PowerOn_Message               := 1;
 BigData_SewInformation                := SEWINFO_STANDARD;
 BigData_MessageModeWithMessageCounter := 1;
 BigData_SendSewInformationWhenPedal0  := 0;
 BigData_RepeatMaxCount                := 0;
 BigData_MessageKeywords               := 0;
 BigData_UserLoginRequired             := 0;
 BigData_WatchdogTime                  := 0;
 BigData_NoACKRunBlockage              := 0;
 BigData_ExternalMachine               := 0;

SetDisplayText("Init Mode",5,0,0);
 SELECT (BigData_DataMode) OF
 
  CASE BIGDATA_MODE_1://Tony-Mode
//   START Section_StitchCount_Task;
   BigData_TxD_RepeatTime                := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation                := SEWINFO_SPECIAL_BACKTACK;//
   //BigData_NoACKRunBlockage := 1;
   
  CASE BIGDATA_MODE_5://EFKA BigData Server Software
   //BigData_MessageModeWithMessageCounter := 1;
   //BigData_RepeatMaxCount                := 10;
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
//zu testzwecken
//   BigData_UserLoginRequired             := 0;
//   BigData_WatchdogTime                  := 0;
//   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
   //BigData_SendNoBackTackInformation     := 1;
 
  CASE BIGDATA_MODE_6://Tony-Mode
   BigData_TxD_RepeatTime               := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation               := SEWINFO_SPECIAL_BACKTACK;//
   BigData_NoACKRunBlockage             := 1;
 
  CASE BIGDATA_MODE_8://Tony-Mode
   BigData_TxD_RepeatTime               := BIGDATA_TX_COMPILER_REPEATTIME;
   BigData_SewInformation               := SEWINFO_SPECIAL_BACKTACK;//
   BigData_SendSewInformationWhenPedal0 := 1;

  CASE BIGDATA_MODE_5://EFKA BigData Server Software
   //BigData_MessageModeWithMessageCounter := 1;
   //BigData_RepeatMaxCount                := 10;
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
//zu testzwecken
//   BigData_UserLoginRequired             := 0;
//   BigData_WatchdogTime                  := 0;
//   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
   //BigData_SendNoBackTackInformation     := 1;
 
  CASE BIGDATA_MODE_12:
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 1;
   BigData_WatchdogTime                  := 10000;
   BigData_ExternalMachine               := 1;
   IF (IsDA321) THEN
    SetParameter(441,0);//IN_EXTERNAL_MACHINE_STITCHCOUNT
    SetParameter(241,0);//IN_EXTERNAL_MACHINE_START
    SetParameter(242,0);//IN_EXTERNAL_MACHINE_END
   ELSE
    SetParameter(240,0);//IN_EXTERNAL_MACHINE_STITCHCOUNT
    SetParameter(241,0);//IN_EXTERNAL_MACHINE_START
    SetParameter(242,0);//IN_EXTERNAL_MACHINE_END
   END_IF;
   
  CASE BIGDATA_MODE_13://EFKA BigData Testversion no Server
   BigData_MessageKeywords               := 1;
   BigData_UserLoginRequired             := 0;
   BigData_WatchdogTime                  := 10000;
   BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
 
 END_SELECT;
 StringCopy(STRING_BigDataString,"");
 
 
 IF (/*(BigData_NoUserRunBlockage > 0) OR*/ (BigData_NoACKRunBlockage > 0)) THEN
  SetDisablePedal  := ON;
  SetRunBlockage   := ON;
  SetDisableOutM6  := ON;
  SetDisableOutM11 := ON;
  //;
 END_IF;
 
 IF (BigData_Ack_Mode = BIGDATA_ACK_MODE_WITH_ACK) THEN
 IF (BigData_PowerOn_Message > 0) THEN
  Power_On_Message_Aktiv := TRUE;
 END_IF;
 END_IF;

// SetAllDisplay_CreateDisplay();
 
// Eval_Minute_Counter := GetParameter(PARA_BIGDATA_EVALUATIONTIME);
 
// NewBigDataArray();
// 
// InitVars();//BRC disable
// WHILE (USBEnumerationIsActive)
// END_WHILE;
 
SetDisplayText("Init Section",5,0,0);
 SECTION_DATA_Init();
 
 
SetDisplayText("Init Barcode",5,0,0);
 //Waitms(1500);
 Barcode_Init();
 //Waitms(1500);
 
 //SetDisablePedal := ON;
 //SetRunBlockage := ON;
 
// SetAllDisplayText(SADT_READY_BIGDATA,0);
 IF (BigData_PowerOn_Message) THEN   
  BigData_SendString(BIGDATA_ID_SEND_POWER_ON);
 END_IF;
 
 PieceCounter_PowerOn();
 ServiceCounter_PowerOn();
 
 
 Val_TASKTIME := GetParameter(PARA_TASKTIME);
 IF (Val_TASKTIME < TASKTIME_MIN) THEN
  Val_TASKTIME := TASKTIME_MIN;
 END_IF;
 IF (Val_TASKTIME > TASKTIME_MAX) THEN
  Val_TASKTIME := TASKTIME_MAX;
 END_IF;
 
 
 IF (BigData_UserLoginRequired) THEN
  SetAllDisplayText(SADT_INIT_LOGIN,0);
 ELSE 
  SetEnableFpPedal := OFF;
  SetAllDisplay_KillDisplay();
 END_IF;

//ELSE//IF (BigData_DataMode) THEN
// KillDisplay();
// SetEnableFpPedal := OFF;
//END_IF;//IF (BigData_DataMode) THEN
 
SetTaskTime(Val_TASKTIME*1);
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Login(BD_Log1 : VALUE, BD_Log2 : VALUE)
 BD_Log1 := VarioButtons;
 IF (BD_Log1) THEN
  SELECT (BD_Log1) OF
//---------------------------------  
//---------------------------------  
   CASE Button1: BD_Log2 := 11;
   CASE Button2: BD_Log2 := 12;
   CASE Button3: BD_Log2 := 13;
   CASE Button4: BD_Log2 := 14;
   CASE Button5: BD_Log2 := 15;
   CASE Button6: BD_Log2 := 16;
   CASE Button7: BD_Log2 := 17;
   CASE Button8: BD_Log2 := 18;
   CASE Button9: BD_Log2 := 19;
   CASE Button0: BD_Log2 := 10;

//---------------------------------  
   CASE ButtonE: //Abschicken
    IF (BigData_Ack_Mode = BIGDATA_ACK_MODE_WITH_ACK) THEN//Wenn Power on Ack noch nicht kam, muss ein Fehler angezeigt werden
    IF (BigData_PowerOn_Message > 0) THEN
    IF (Power_On_Message_Aktiv) THEN
     SetBeepShort();
     SetAllDisplayText(SADT_ERROR_A19,BIGDATA_ERROR_TX_TIMEOUT);
    END_IF;
    END_IF;
    END_IF;
   
   
    ValueToString(STRING_BARCODE,Login_Value);
    Login_Stelle := StringLen(STRING_BARCODE);
    StringCopy(STRING_BARCODE,"");
    WHILE (Login_Stelle < 10)
     StringAppend(STRING_BARCODE,"0");
     Login_Stelle := Login_Stelle + 1;
    END_WHILE;
    ValueToString(STRING_CODE,Login_Value);
    StringAppend(STRING_BARCODE,STRING_CODE);
    IF (Login_Value) THEN
     SELECT (ActualDisplay) OF
      CASE DISPLAY_CONT_LOGIN:
       SetUserID();
      CASE DISPLAY_CONT_SERVICECALL:
       SetServiceCall();
     END_SELECT; 
     ActualDisplay := DISPLAY_WAIT_LOGIN;
    END_IF;

//---------------------------------  
   CASE ButtonP: //Aktuelle Eingabe lschen
    Login_Stelle := 0;
    Login_Value  := 0;
    SELECT (ActualDisplay) OF
     CASE DISPLAY_CONT_LOGIN:
      ShowUserValue();
     CASE DISPLAY_CONT_SERVICECALL:
      //ShowServiceCall();
     ActualDisplay := DISPLAY_WAIT_LOGIN;
     ActualDisplay := DISPLAY_INIT_SEWING;
     SetAllDisplay_KillDisplay();
    END_SELECT; 

//---------------------------------  
//---------------------------------  
  END_SELECT;

  IF (BD_Log2) THEN
   BD_Log2 := BD_Log2 - 10;
   IF (Login_Stelle >= 4) THEN
    Login_Stelle := 0;
    Login_Value := 0;
   END_IF; 

   ValueToString(STRING_CODE,Login_Value);
   ValueToString(STRING_CODE2,BD_Log2*1);
   StringAppend(STRING_CODE,STRING_CODE2);   
   Login_Value := StringToValue(STRING_CODE);
   Login_Stelle := Login_Stelle + 1;
//   IF (Login_Aktiv) THEN
//    ShowUserValue();
//   END_IF;    
//   IF (ServiceCall_Aktiv) THEN
//    ShowServiceCall();
//   END_IF;
   SELECT (ActualDisplay) OF
    CASE DISPLAY_CONT_LOGIN:
     ShowUserValue();
    CASE DISPLAY_CONT_SERVICECALL:
     ShowServiceCall();
   END_SELECT; 
   
   
  END_IF;
  WHILE (VarioButtons)
  END_WHILE;
 END_IF;
END_PROCEDURE


//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_SewDisplay()
//SetDisplayText(STRING_OPERATOR,1,0,0);
//SELECT (Benutzer_Ebene) OF
// CASE STATUS_MECHANIC:
//  DisplayCharacterSet("mech",0,0);
// CASE STATUS_OPERATOR:
//  DisplayCharacterSet("user",0,0);
//END_SELECT;
//SetDisplayValue(Benutzer_Ebene,2,0,0);
//SetDisplayValue(OfsRdRxD*1,3,0,0);
IF (NOT MotorRun) THEN
 IF (NOT SeamFreeRun) THEN

IF (Anzeige_Naht_Text_neu <> Anzeige_Naht_Text_alt) THEN 
  CreateDisplay();
  SELECT (Anzeige_Naht_Text_neu) OF
   CASE DISPLAY_INIT_CALL_SET:
    SetDisplayText("call",2,0,0);
    SetDisplayText(" set",3,0,0);
   CASE DISPLAY_INIT_CALL_OK:
    SetDisplayText("call",2,0,0);
    SetDisplayText(" ok",3,0,0);
  END_SELECT;
  Anzeige_Naht_Text_neu := Anzeige_Naht_Text_alt;
END_IF;

  Merker_VarioButtons := VarioButtons;
  IF (Merker_VarioButtons) THEN
   SELECT (Merker_VarioButtons) OF
    CASE ButtonF1:
    
     BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);
     SetAllDisplayText(SADT_INIT_LOGIN,0);   
    CASE ButtonF2:
     SetAllDisplayText(SADT_INIT_SERVICECALL,0);
     Anzeige_Naht_Text_neu := DISPLAY_INIT_CALL_SET;
   END_SELECT;
   Waitms(100);
   WHILE (VarioButtons)
   END_WHILE;
  END_IF; 
 END_IF;
END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Barcode_Manager()
 IF (GetLine(1,STRING_BARCODE)) THEN//Sind Daten vom RFID Reader vorhanden?
  IF ( (VAL_USER_ID_1 > 0) OR (VAL_USER_ID_2 > 0) OR (VAL_USER_ID_3 > 0) ) THEN//Ist User angemeldet? 
   BigData_SendString(BIGDATA_ID_SEND_OPERATOR_ID_LOGOUT);//dann abmelden
   SetAllDisplayText(SADT_INIT_LOGIN,0);   
  ELSE//Ist kein User angemeldet?
   SELECT (ActualDisplay) OF//dann anmelden
    CASE DISPLAY_CONT_LOGIN:
     SetUserID();
     ActualDisplay := DISPLAY_WAIT_LOGIN;
   END_SELECT; 
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
//PROCEDURE RunBlockage_Manager()
// IF (BigData_NoUserRunBlockage > 0) THEN
//  BigData_SetRunBlockage();
// END_IF;
//END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Display_Manager()
 SELECT (ActualDisplay) OF
  CASE DISPLAY_INIT_SEWING:
   ActualDisplay := DISPLAY_CONT_SEWING;
  CASE DISPLAY_INIT_LOGIN:
   ShowUserValue();
   ActualDisplay := DISPLAY_CONT_LOGIN;
  CASE DISPLAY_INIT_SERVICECALL:
   ShowServiceCall();
   ActualDisplay := DISPLAY_CONT_SERVICECALL;
 
  CASE DISPLAY_CONT_SEWING:
   BigData_SewDisplay();
  CASE DISPLAY_CONT_LOGIN:
   BigData_Login(0,0);
  CASE DISPLAY_CONT_SERVICECALL:
   BigData_Login(0,0);
   
  CASE DISPLAY_WAIT_LOGIN:
   dummy := dummy;
 END_SELECT;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE Watchdog_Manager()
 IF (BigData_WatchdogTime) THEN
  IF (NOT Power_On_Message_Aktiv) THEN
  // IF (BigData_WatchdogRun) THEN
    IF (NOT TimerIsRunning(TIMER_WATCHDOGMESSAGE)) THEN
     //SetBeepShort();
     WatchdogTimerReset();
     BigData_SendString(BIGDATA_ID_SEND_WATCHDOGMESSAGE);
    END_IF;
  // END_IF;
  END_IF;
 END_IF;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE ServiceTimerCounter_Manager()
 ServiceCounter_Act_1 := ServiceCounter_Manager(1, ServiceCounter_Startwert_1*1, ServiceCounter_Mode_1*1, ServiceCounter_Act_1*1 ,0);
 ServiceCounter_Act_2 := ServiceCounter_Manager(2, ServiceCounter_Startwert_2*1, ServiceCounter_Mode_2*1, ServiceCounter_Act_2*1 ,0);
 ServiceCounter_Act_3 := ServiceCounter_Manager(3, ServiceCounter_Startwert_3*1, ServiceCounter_Mode_3*1, ServiceCounter_Act_3*1 ,0);
 ServiceCounter_Act_4 := ServiceCounter_Manager(4, ServiceCounter_Startwert_4*1, ServiceCounter_Mode_4*1, ServiceCounter_Act_4*1 ,0);
 ServiceCounter_Act_5 := ServiceCounter_Manager(5, ServiceCounter_Startwert_5*1, ServiceCounter_Mode_5*1, ServiceCounter_Act_5*1 ,0);
 //Reinit
 ServiceCounter_ExecuteCount := 0;
 ServiceCounter_ExecuteTime := 0;
END_PROCEDURE

//-------------------------------------------------------------------------------------------------------
PROCEDURE BigData_Cont()


IF (GetParameter(PARA_SHOW_CYCLE_TIME)) THEN
// CreateDisplay();
// SetDisplayValue(Counter_SHOW_CYCLE_TIME,1,0,0);
 IF (Counter_SHOW_CYCLE_TIME = 0) THEN
  Counter_SHOW_CYCLE_TIME := 50;
  CreateDisplay();
  SetDisplayValue(10000 - GetTimer(TIMER_SHOW_CYCLE_TIME),2,0,0);
  ClearTimer(TIMER_SHOW_CYCLE_TIME);
  SetTimer(TIMER_SHOW_CYCLE_TIME,10000);
 END_IF;
 Counter_SHOW_CYCLE_TIME := Counter_SHOW_CYCLE_TIME - 1;
END_IF;


 IF (BigData_DataMode) THEN

  BigData_RxTx_Manager();


  SELECT (Ablauf_BigData_Cont) OF 
//------------------------------------------Dongle  
   CASE 1://Donle-Init
    SetDisplayText("Dong Detect",5,0,0);
    StringMessageMode := SetSystemInfo(SYSTEMINFO_StringMessageMode,1);
    BigData_Ack_Mode                      := BIGDATA_ACK_MODE_WITH_ACK;
    BigData_TxD_RepeatTime                := BIGDATA_TX_REPEATTIME;
    BigData_MessageKeywords               := 1;
    BigData_MessageModeWithMessageCounter := 0;
    BigData_SendString(DONGLE_ID_SEND_DETECT_REQUEST);
    SetTimer(TIMER_DONGLE,10000);
    Ablauf_BigData_Cont := 101;//Wait for answer
   CASE 2:// 
    SetDisplayText("Dong Enable",5,0,0);
    Dongle_Typ := SpecialFunction(SF_DONGLE_CHECK,Dongle_Val1,Dongle_Val2,Dongle_Val3,Dongle_Val4,Dongle_Val5,Dongle_Val6,Dongle_Val7,Dongle_Val8,1,0,0,0,0,0,0,0,0,0,0);
    SELECT (Dongle_Typ) OF
     CASE 1://BigData
      BigData_Ack_Mode                      := BIGDATA_ACK_MODE_NO_ACK;
      BigData_TxD_RepeatTime                := 0;
      BigData_MessageKeywords               := 1;
      BigData_MessageModeWithMessageCounter := 0;
      BigData_SendString(DONGLE_ID_SEND_DETECT_ENABLE);
      //SetTimer(TIMER_DONGLE,1000);
      Ablauf_BigData_Cont := 102;//Warten bis abgeschickt
    ELSE:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,5);
     Fkt_While();
    END_SELECT; 
    
   CASE 101:
    SetDisplayText("Dong Wait",5,0,0);
    IF (NOT TimerIsRunning(TIMER_DONGLE)) THEN
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,1);
     Fkt_While();
    END_IF;
//   CASE 102:
//    IF (NOT TimerIsRunning(TIMER_DONGLE)) THEN
//     Ablauf_BigData_Cont := 500;
//    END_IF;
    
   CASE 110:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,2);
     Fkt_While();
   CASE 111:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,3);
     Fkt_While();
   CASE 112:
     SetAllDisplay_CreateDisplay();
     SetAllDisplayText(SADT_ERROR_DONGLE,4);
     Fkt_While();
     
//------------------------------------------BigData  
   CASE 500://BigData Init
    BigData_Init();
    Ablauf_BigData_Cont := 501;
   CASE 501://BigData Cont
    Barcode_Manager();
    Display_Manager(); 
    Watchdog_Manager();
    SELECT (BigData_ExternalMachine) OF
     CASE 1:
      ExternalMachine_Manager(0);
     ELSE:
      Seam_Data_neuManager(0);
    END_SELECT;  
    PieceCounter_Manager();
    ServiceTimerCounter_Manager();
    //RunBlockage_Manager(); 

  END_SELECT;
 END_IF;
 
// CycleCounter := CycleCounter + 1;
// SetDisplayValue(CycleCounter,1,0,0);
// SetDisplayValue(Ablauf_SendStringTest,2,0,0);
// //SetDisplayValue(BigData_TxManager_ActualFillBuffer,3,0,0);
// SetDisplayValue(Ablauf_BigData_Cont,3,0,0);
//      SetDisplayText(STRING_BigDataString,5,0,0);

 
END_PROCEDURE



//-------------------------------------------------------------------------------------------------------
END_UNIT
